#include </usr/include/sys/io.h>
// Dieses Programm luft nur unter root


 void Oeffnen_COM(unsigned int,int Baudrate);
 unsigned char RXD_DatenAngekommen();
 unsigned char Empfangen_COM();
 void Senden_COM (unsigned char);
 void RTS_Leitung(int setzen);
 void Schliessen_COM();


 unsigned int const  COM1=0x3F8,
                     COM2=0x2F8,
                     COM3=0x3E8,
                     COM4=0x2E8;

 int Steuerregister=3;

 unsigned int COM_Adresse_xF8,
              COM_Adresse_xF9,
              COM_Adresse_xFB,
              COM_Adresse_xFC,
              COM_Adresse_xFD;

  unsigned char InputRS232,OutputRS232;

  void Oeffnen_COM(unsigned int COM_Adresse,int Baudrate)
  {  // Mgliche Baudraten 1200,2400,4800,"9600","19200",38400,57600,115200
        unsigned char dummy,Teiler;
        // Adressen berechnen
        COM_Adresse_xF8=COM_Adresse;
        COM_Adresse_xF9=COM_Adresse+1;
        COM_Adresse_xFB=COM_Adresse+3;
        COM_Adresse_xFC=COM_Adresse+4;
        COM_Adresse_xFD=COM_Adresse+5;

        // Ports freigeben
        ioperm(COM_Adresse_xF8,3,1);
        ioperm(COM_Adresse_xF9,3,1);
        ioperm(COM_Adresse_xFB,3,1);
        ioperm(COM_Adresse_xFC,3,1);
        ioperm(COM_Adresse_xFD,3,1);

        Teiler=115200/Baudrate;

        outb(128,COM_Adresse_xFB);            // Baudeingabe aktivieren
        outb(Teiler,COM_Adresse_xF8);         // Baudrate einstellen
        outb(0,COM_Adresse_xF9);              // Baudrate - MSB
        outb(3,COM_Adresse_xFB);              // 8 Bits , No Parity , 1 Stopbit
        outb(Steuerregister,COM_Adresse_xFC); // DTR=1, RTS=1
        dummy=inb(COM_Adresse_xF8);           // Empfangsregister leeren
 } // ENDE Oeffnen_COM

  void Schliessen_COM()
  {   outb(0,COM_Adresse_xFC);
      // Ports sperren
      ioperm(COM_Adresse_xF8,3,0);
      ioperm(COM_Adresse_xF9,3,0);
      ioperm(COM_Adresse_xFB,3,0);
      ioperm(COM_Adresse_xFC,3,0);
      ioperm(COM_Adresse_xFD,3,0);
  } // ENDE Schliessen_COM()


  void Senden_COM(unsigned char Wert)
  {  while((inb(COM_Adresse_xFD) & 32)!= 32); // warten bis Senderegister leer ist
     outb(Wert,COM_Adresse_xF8);  // Daten in das Senderegister schreiben
  } //ENDE Senden_COM


  unsigned char RXD_DatenAngekommen()
  {  return  (inb(COM_Adresse_xFD) & 1);
  } //ENDE RXD_DatenAngekommen


  unsigned char Empfangen_COM()
  {  int  DatenEmfangen=false,wert=0;;


     do
     { DatenEmfangen=(inb(COM_Adresse_xFD) & 1);
     } while(DatenEmfangen==false );

     if (DatenEmfangen) wert=inb(COM_Adresse_xF8);
     return wert;
  } // ENDE Empfangen_COM()


  void RTS_Leitung(int setzen)
  {   if (setzen)
        Steuerregister=Steuerregister | 2;   // RTS=1
      else
        Steuerregister=Steuerregister & 253; // RTS=0

      outb(Steuerregister,0x3FC);
  } // ENDE RTS_Leitung

main()
{	unsigned char EByte,AByte;
	Oeffnen_COM(COM1,9600);
  RTS_Leitung(false);

	while(true)
	{	Senden_COM(AByte);
		EByte=Empfangen_COM();

		AByte++;
	}
	Schliessen_COM();
}



